# ibm-si-rest-sample

# IBM Storage Insights - Python sample code to use IBM Storage Insights REST APIs

## Introduction
This Python application allows to interact with the IBM Storage Insights (SI) REST API service.
The CLI commands are making use of the SI functionality via the service's
REST API.

## Prerequisites
To make use of the CLI, you need following two items:
- IBM SI Tenant id
- IBM SI REST API Key

These details are required to be filled in the configuration file `config.ini` before running the Python scripts.

You need to obtain your REST API key(s) to use for the application via the
[IBM Storage Insights](https://insights.ibm.com) application.

The sample application requires a Python 3.6+ runtime environment.

Install the required dependencies
```shell
pip install -r requirements.txt
```

## Usage
```Shell
> python si.py -h

usage: si.py [-h] {list_storage_systems,list_storage_system_vol,list_alerts,list_notifications} ...

IBM Storage Insights REST API.

positional arguments:
  {list_storage_systems,list_storage_system_vol,list_alerts,list_notifications}
                        Choose a REST API to invoke
    list_storage_systems
                        List storage systems
    list_storage_system_vol
                        List volumes of storage systems
    list_alerts         List alerts for a tenant
    list_notifications  List notifications for a tenant

options:
  -h, --help            show this help message and exit

```

List all the block storage systems of a tenant
```shell
python si.py list_storage_systems --system-type block
```

List all the volumes of a storage system
```shell
python si.py list_storage_system_vol --system-uuid <system-uuid>
```

List all the alerts for a tenant in last 1 day with severity warning
```shell
python si.py list_alerts --duration 1d --severity warning
```

List all the notifications for a tenant in last 1 day with severity warning
```shell
python si.py list_notifications --duration 1d --severity warning
```


For more information go to the [IBM Storage Insights REST API Documentation](https://insights.ibm.com/openapi/ui/)
